package com.elitesland.user.controller;

import com.elitesland.common.dto.user.DemoUserDTO;
import com.elitesland.common.rpc.demo.DemoRpcProductService;
import com.elitesland.common.rpc.user.UserRpcDemoService;
import com.elitesland.core.base.ApiResult;
import com.elitesland.user.service.UserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.DubboReference;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 * 功能说明
 * </p >
 *
 * @author Roman.Zhang
 * @date 2021/1/29
 */
@RestController
@RequestMapping("/user")
@RequiredArgsConstructor
@Slf4j
@Api(value = "用户服务-用户基本信息接口", tags = {"用户服务-用户基本信息接口"})
public class UserDemoController {

    private final UserService userService;

    @DubboReference(version = "${provider.service.version}")
    private UserRpcDemoService userRpcDemoService;

    @GetMapping("/register")
    public ApiResult<Object> register() {
        return ApiResult.ok("hello 用户中心");
    }

    @PostMapping("/getUser")
    public ApiResult<Object> getUser(String username){
        log.info("receive param is : "+ username);
        return  ApiResult.ok(userService.getUser(username));
    }


    @ApiOperation("通过用户服务远程调用Demo服务-测试演示")
    @PostMapping("/getDemo")
    public ApiResult<Object> getDemo(String demo){
        return ApiResult.ok(userRpcDemoService.getDemo(demo));
    }
}
