package com.elitesland.user.service.rpc;

import com.elitesland.common.dto.product.DemoProductDTO;
import com.elitesland.common.dto.user.DemoUserDTO;
import com.elitesland.common.rpc.demo.DemoRpcProductService;
import com.elitesland.common.rpc.demo.DemoRpcUserService;
import com.elitesland.core.base.ApiResult;
import com.elitesland.user.service.UserService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import lombok.val;
import org.apache.dubbo.config.annotation.DubboService;
import org.springframework.util.StringUtils;

/**
 * <p>
 * 功能说明
 * </p >
 *
 * @author Roman.Zhang
 * @date 2021/1/30
 */
@Slf4j
//@Service("syncServiceRpc")
@DubboService(version = "${provider.service.version}", timeout = 1200000)
@RequiredArgsConstructor
public class UserRpcServiceImpl implements DemoRpcUserService {

    private final UserService userService;

    @Override
    public ApiResult<Object> getUser(DemoUserDTO demoUserDTO) {
        val product  = demoUserDTO!=null && StringUtils.isEmpty(demoUserDTO.getUserName()) ?
                "数据信息不符合要求":userService.getUser(demoUserDTO.getUserName());
        return ApiResult.ok(product);
    }
}
